#include <stdio.h>
#include <string.h>
#include "lua.h"
#include "lauxlib.h"
#include "lualib.h"

void load (lua_State *L, const char *fname, int *w, int *h);

int main(void) {
    lua_State *L = luaL_newstate();   /* opens Lua */
    luaL_openlibs(L);             /* opens the standard libraries */
    char filename[] = "C:/Lua C and C++/workspace/widthHeight.lua";
    int width = 0;
    int height = 0;
    load(L, filename, &width, &height);
    printf("width is %d\n\n", width);
    printf("height is %d", height);
    return 0;
}

void load (lua_State *L, const char *fname, int *w, int *h) {
	if (luaL_loadfile(L, fname) || lua_pcall(L, 0, 0, 0)) {
		luaL_error(L, "cannot run config file: %s", lua_tostring(L, -1));
	}
	lua_getglobal(L, "width");
	lua_getglobal(L, "height");
	if (!lua_isnumber(L, -2)) {
		luaL_error(L, "'width' should be a number\n");
	}
	if (!lua_isnumber(L, -1)) {
		luaL_error(L, "'height' should be a number\n");
	}
	*w = lua_tointeger(L, -2);
	*h = lua_tointeger(L, -1);
}
