#include <stdio.h>
#include <string.h>
#include "lua.h"
#include "lauxlib.h"
#include "lualib.h"

void load (lua_State *L, const char *fname, int *red, int *green, int *blue);
int getcolorfield(lua_State *L, const char *key);

#define MAX_COLOR 255
int main(void) {
    lua_State *L = luaL_newstate();   /* opens Lua */
    luaL_openlibs(L);             /* opens the standard libraries */
    char filename[] = "C:/Lua C and C++/workspace/configTable.lua";
    int red = 0;
    int green = 0;
    int blue = 0;
    load(L, filename, &red, &green, &blue);
    printf("red is %d\n", red);
    printf("green is %d\n", green);
    printf("blue is %d", blue);
    return 0;
}

void load (lua_State *L, const char *fname, int *red, int *green, int *blue) {
	if (luaL_loadfile(L, fname) || lua_pcall(L, 0, 0, 0)) {
		luaL_error(L, "cannot run config file: %s", lua_tostring(L, -1));
	}
	lua_getglobal(L, "background");
	if (!lua_istable(L, -1)) {
			luaL_error(L, "'background' is not a table\n");
	}
	int r = getcolorfield(L, "r");
	int g = getcolorfield(L, "g");
	int b = getcolorfield(L, "b");

	*red = r;
	*green = g;
	*blue = b;
}

int getcolorfield(lua_State *L, const char *key) {
	int result;
	lua_pushstring(L, key);
	lua_gettable(L, -2);
	if (!lua_isnumber(L, -1)) {
		luaL_error(L, "invalid component in background color");
	}
	result = (int)(lua_tonumber(L, -1) * MAX_COLOR);
	lua_pop(L, 1);
	return result;
}
